﻿<?php
///////////////////////////////////////////////////////////////////////////
require_once 'utils.php';

class Cursor
{

	    private $m_feed;
	    private $m_feed_url;
	    private $m_items_count;
        private $m_last_ref;

    ///////////////////////////////////////////////////////////////////////

    public function __construct($media_url)
    {
        if ($media_url === 'main_menu:fav')
            $this->m_feed_url = 'main_menu:fav';
        else
            HD::decode_user_data($media_url, $media_str, $this->m_feed_url);

        $this->m_items_count = 0;
        $this->m_feed = 0;
        $this->m_last_ref = "";
		$this->m_next_ref = '';
    }

    private function parse_page($url)
    {
        $items = array();
        $doc = HD::http_get_document($url);
		$jsd = json_decode($doc, true);
		if (isset($jsd['nextPageToken']))
		$this->m_next_ref = $jsd['nextPageToken'];
		else
			$this->m_next_ref = 'stop';
        foreach ($jsd['items'] as $value){
			$playlistItem = 0;
			if (isset($value['id']['videoId']))
            $season_ref = $value['id']['videoId'];
			if (isset($value['id']['playlistId'])){
            $season_ref = $value['id']['playlistId'];
			$playlistItem = 1;
			}
			if (isset($value['id']['channelId'])){
            $season_ref = $value['id']['channelId'];
			$playlistItem = 2;
			}
			if ((isset($value['kind']))&&($value['kind']=='youtube#video')){
            $season_ref = $value['id'];
			$playlistItem = 0;
			}
			$liveBroadcastContent = '';
			if ((isset($value['snippet']['liveBroadcastContent']))&&($value['snippet']['liveBroadcastContent'] == 'live'))
				$liveBroadcastContent = '[live]';
			
			$season_image = str_replace("https", "http", $value['snippet']['thumbnails']['medium']['url']);
			$season_title = str_remove_spec($value['snippet']['title']);
			$season_desc = $value['snippet']['description'];
			$channelTitle = $value['snippet']['channelTitle'];
			$channelId = $value['snippet']['channelId'];
			$season_date = str_replace(array ("T",".000Z"), " ", $value['snippet']['publishedAt']);
            array_push
            (
                $items,
                HD::encode_user_data
                (
                    array
                    (
                        'video_id' => $season_ref,
                        'season_title' => $season_title,
                        'season_ref' => $season_ref,
                        'season_image' => $season_image,
						'season_desc' => $season_desc,
						'season_date' => $season_date,
						'playlistItem' => $playlistItem,
						'channelTitle' => $channelTitle,
						'channelId' => $channelId,
						'lBC' => $liveBroadcastContent,
                        'is_has_new' => false
                    )
                )
            );
            ++$this->m_items_count;
        }
        
        return $items;
    }

    private function parse_subcategory($current_sort_page)
    {
        $subcategory = $this->m_feed_url;
        $url = $subcategory->subcategory_ref . "&order=$current_sort_page";
        if ($this->m_feed > 0)
            $url = $subcategory->subcategory_ref . $this->m_next_ref."&order=$current_sort_page";
        return $this->parse_page($url);
    }

    ///////////////////////////////////////////////////////////////////////
    private function parse_search_result($search)
    {	
        return $this->parse_page($search);
    }
    ///////////////////////////////////////////////////////////////////////

    private function get_next_fav(&$plugin_cookies)
    {
		$fav_items = HD::get_items('fav_items', &$plugin_cookies);     
        $ref = "";
        $n = 0;
        foreach ($fav_items as $key => $item)
        {
            if ($item == "")
                continue;
            if ($n == $this->m_feed)
                $ref = $item;
            ++$n;
        }
        if ($ref == "")
            return false;
        $items = array();
        $c = VideoCache::get($ref);
        if (!is_null($c))
        {
            array_push
            (
                $items,
                $c
            );
            ++$this->m_items_count;
            return $items;
        }
		$fav_links = HD::get_items('fav_items_link', &$plugin_cookies);	
		if (isset($fav_links[$ref]))
		{
			$season_title = $fav_links[$ref]['title'];
			$season_image = $fav_links[$ref]['img'];
			$playlistItem = $fav_links[$ref]['playlistItem'];
		}
        array_push
        (
            $items,
            HD::encode_user_data
            (
                array
                (
                    'video_id' => $ref,
                    'season_title' => $season_title,
                    'season_ref' => $ref,
                    'season_image' => $season_image,
                    'is_has_new' => false,
					'playlistItem' => $playlistItem,
                )
            )
        );

        ++$this->m_items_count;

        return $items;
    }
    ///////////////////////////////////////////////////////////////////////

    public function next_chunk($plugin_cookies)
    {
	    $current_sort_page = (HD::get_item('sort_page', &$plugin_cookies)!=='') ? HD::get_item('sort_page', &$plugin_cookies) : 'relevance';
	    $items = array();
        if ($this->m_feed_url === 'main_menu:fav')
        {
            $items = $this->get_next_fav($plugin_cookies);
            ++$this->m_feed;
            if ($items === false)
                return false;
            
            return count($items) > 0 ? $items : false;
        }
	    if (HD::has_attribute($this->m_feed_url, 'ser_feed'))
	    {
			
			if ($this->m_next_ref == 'stop')
				return false;
			$search_text = HOST_API_URL . "/search?order=$current_sort_page&part=snippet&q=".$this->m_feed_url->ser_feed."&type=".$this->m_feed_url->ser_link."&maxResults=50&pageToken=".$this->m_next_ref."&key=".API_KEY;
            $items = $this->parse_search_result($search_text);
            ++$this->m_feed;
            if ($items === false)
                return false;
            return count($items) > 0 ? $items : false;
	    }
        else if (HD::has_attribute($this->m_feed_url, 'subcategory_ref'))
        {
		   if ($this->m_next_ref == 'stop')
				return false;
		   $items = $this->parse_subcategory($current_sort_page);
            ++$this->m_feed;
            if ($items === false)
                return false;
            return count($items) > 0 ? $items : false;
        }
        return false;
    }
}

///////////////////////////////////////////////////////////////////////////
?>
